/***********************************************************************
<t@C>	cameralb.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
	Ver.2.0 for MI-500
	Ver.3.0 for MI-EX1
***********************************************************************/

/***********************************************************************
		CCDJJ[hIOCS Cu`
***********************************************************************/


#ifndef _CAMERALB_H_INCLUDED
#define _CAMERALB_H_INCLUDED

#include <sharpgen.h>
#include <message.h>
#include <ioercode.h>
#include <offscrn.h>

/*======================================================================
				G[R[h
======================================================================*/

typedef enum CAMDERRCODE {
	EC_CAMERA_NOT_EXIST	= -1, 	/* JJ[h͐ڑĂȂ */
	EC_CAMERA_BAD_PARAM = -2,	/* ̒l */
	EC_CAMERA_BAD_PTR = -3, 	/* [N|C^ */
	EC_CAMERA_BROKEN_WORK = -4, /* [Ne */
	EC_CAMERA_BAD_STATE = -5, 	/* JJ[h̏Ԃ */
	EC_CAMERA_NOT_SUPPORT = -6,
	EC_CAMERA_FATAL_ERROR = -7,
	EC_CAMERA_LOCKED = -8,
	EC_CAMERA_BAD_DRIVER = -9
} CAMDERRCODE;

/*======================================================================
				萔`
======================================================================*/

#define	CARDTYPE_CAMERA	0x43414D45	/* 'CAME' */

/* ֐ SocketNo */
#define	CAMERA_SOCKET0	0 /* PC-Card socket#0ɑ}ꂽJ */
/* QXbg@gɑΉł悤 */

#define CAMERA_SOCKET16	16


/*======================================================================
				^`
======================================================================*/

typedef UCHAR CAMERANAME[40];

/* JZbVŎgp郏[N */
/* ۂɂ͂̌ɃhCõ[N */
typedef	struct CAMERA {
	UINT	socketNo;
} CAMERA;


typedef struct EMSG_CAMERAEVENT {
	USHORT	MessageID;
	USHORT	OccuredTime;
	APLID	AplName;
	USHORT	EventID;
} EMSG_CAMERAEVENT;

/**** EMSG_CAMERAEVENT.EventID ***/
#define	CAMERA_SW_CHANGED		0x0001	/* JdXCb`삳ꂽ */
#define	CAMERA_SHUTTER_PUSHED	0x0002	/* Vb^[{^ꂽ */

/* ݒ^Cv */
typedef enum CAMCONFTYPE {
	CAMCON_SIZE,		/* ǂ݂TCY - ͖₢킹̂ */
	CAMCON_WHITEMODE,	/* zCg[h */
	CAMCON_SHARPNESS,	/* V[vlX */
	CAMCON_LIGHT,		/* I */
	CAMCON_ZOOM,		/* Y[ */
	CAMCON_HIGH_QUALITY,	/* 掿D惂[h  */

	CAMCON_DMAMODE,		/* Lv`ݒ(DMA) */
	CAMCON_YUVRGB,		/* f[^`(YUV/RGB) */
	CAMCON_CONDITION,	/* Be󋵐ݒ */
	CAMCON_AE_AWB_HOLD	/* ACXƃzCgoX̎~ */
} CAMCONFTYPE;

/* ₢킹rbg(32bitl) */
/* CAMCONFTYPEɑgݍ킹Ďgp */
#define	CAMCON_IS_AVAILABLE	0x80000000

/* Iݒ胂[h */
#define	CAMCON_LIGHT_INC	1	/* Pグ */
#define	CAMCON_LIGHT_DEC	2	/* P */
#define	CAMCON_LIGHT_RESET	0	/* Zbg(Wɖ߂) */

/* DMA (LCDɉ摜o͂@\) */
#define	CAMCON_DMA_START	0	/* DMAJn */
#define	CAMCON_DMA_STOP		1	/* DMA~ */

/* f[^` (YUV/RGB) */
#define	CAMCON_DATA_RGB		0	/* RGBf[^` (default) */
#define	CAMCON_DATA_YUV		1	/* YUVf[^` */

/* Be󋵐ݒ */
typedef enum CAMCONDITION {
	CAMCOND_INIT,		/* Beݒ */
	CAMCOND_AUTO,		/* Beݒ */
	CAMCOND_PERSON,		/* lBeݒ */
	CAMCOND_SCENERY,		/* iBeݒ */
	CAMCOND_DOCUMENT		/* Beݒ */
} CAMCONDITION;

/* ACXƃzCgoX̎~ */
#define	CAMCON_AWBAF_HOLD	0	/* ݂̏ԂŃACXEzCgoX
					   z[h */
#define	CAMCON_AWBAF_AUTO	1	/* I[gԂɖ߂ */


/*======================================================================
				Cu֐vg^Cv錾
======================================================================*/

/* 320x240[dots] */
/* typedef USHORT CAMERAIMGBUF[76800]; */
typedef UCHAR *CAMERAIMGBUF;

int InitCameraIOCS( int initLevel );
CAMDERRCODE GetCameraInfo( UINT SocketNo, CAMERANAME *pName );
CAMERA *OpenCamera( UINT SocketNo );
CAMDERRCODE CloseCamera( CAMERA *pCam );
CAMDERRCODE ActivateCamera( CAMERA *pCam );
CAMDERRCODE StartCaptureCamera( CAMERA *pCam );
CAMDERRCODE DeactivateCamera( CAMERA *pCam );
CAMDERRCODE DispCameraPhoto( CAMERA *pCam,ULONG zoom );
CAMDERRCODE GetCameraPhoto(CAMERA *pCam,WINDOWHD osHandle,
					   RECTANGLE *destRect,ULONG zoom);
BOOLEAN IsPressedTrigCamera( CAMERA *pCam );
CAMDERRCODE SetConfigCamera(CAMERA *pCam,CAMCONFTYPE type,...);
CAMDERRCODE SetDefaultCameraApl(UINT socketNo,APLID aplName);
BOOLEAN CameraSetupDialog(CAMERA *pCam,MESSAGE *message);


BOOLEAN IsFocusedCamera( CAMERA *pCam );


/*======================================================================
				t@NVR[h
======================================================================*/

#define	INIT_CAMERA_IOCS		0x40 /*  */
/* 0x41`0x49܂ł͌݊̂ߗ\ */
#define	GET_CAMERA_INFO			0x4a /* JJ[h̏𓾂 */
#define	OPEN_CAMERA				0x4b /* JJ[hgn߂ */
#define	CLOSE_CAMERA			0x4c /* JJ[hgI */
#define	ACTIVATE_CAMERA			0x4d /* JBeԂɂ */
#define	DEACTIVATE_CAMERA		0x4e /* Jd́iBeԁjɂ */
#define	START_CAPTURE_CAMERA	0x4f /* J̉摜荞݂Jn */
#define	DISP_CAMERA_PHOTO		0x50 /* J摜Pt[\ */
#define	GET_CAMERA_PHOTO		0x51 /* J摜̃f[^𓾂 */
#define	IS_PRESSED_TRIG_CAMERA	0x52 /* J̃XCb`̏Ԃ𓾂 */
#define	SET_CONFIG_CAMERA		0x53 /* J̐ݒs */
#define	GET_CAM_SOCKET_WORK_PTR	0x54 /* \Pbg[N|C^𓾂 */
#define	SET_DEFAULT_CAMERA_APL	0x55 /* ftHgJAv̎w */
#define	CAMERA_SETUP_DIALOG		0x56 /* JRg[pl */
#define	IS_FORCUSED_CAMERA		0x57 /* J̃sg̏Ԃ𓾂 */

#define	CAM_IOCS_LAST_FUNC		IS_FORCUSED_CAMERA


#endif /* #ifndef _CAMERALB_H_INCLUDED */
