/***********************************************************************
<t@C>	cistuple.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		CIS tuple ̒`
***********************************************************************/

#ifndef	_CISTUPLE_H_INCLUDED
#define	_CISTUPLE_H_INCLUDED

#include <sharpgen.h>


/***********************************************************************
			CIS Tuple
***********************************************************************/

#define	CISTPL_NULL				((UCHAR)0x00)	/*  */
#define	CISTPL_DEVICE			((UCHAR)0x01)	/*  */
#define	CISTPL_LONGLINK_CB		((UCHAR)0x02)	/*  */

#define	CISTPL_CONFIG_CB		((UCHAR)0x04)	/*  */
#define	CISTPL_CFTABLE_ENTRY_CB	((UCHAR)0x05)	/*  */
#define	CISTPL_LONGLINK_MFC		((UCHAR)0x06)	/*  */
#define	CISTPL_BAR				((UCHAR)0x07)	/*  */

#define	CISTPL_CHECKSUM			((UCHAR)0x10)	/*  */
#define	CISTPL_LONGLINK_A		((UCHAR)0x11)	/*  */
#define	CISTPL_LONGLINK_C		((UCHAR)0x12)	/*  */
#define	CISTPL_LINKTARGET		((UCHAR)0x13)	/*  */
#define	CISTPL_NO_LINK			((UCHAR)0x14)	/*  */
#define	CISTPL_VERS_1			((UCHAR)0x15)	/*  */
#define	CISTPL_ALTSTR			((UCHAR)0x16)	/*  */
#define	CISTPL_DEVICE_A			((UCHAR)0x17)	/*  */
#define	CISTPL_JEDEC_C			((UCHAR)0x18)	/*  */
#define	CISTPL_JEDEC_A			((UCHAR)0x19)	/*  */
#define	CISTPL_CONFIG			((UCHAR)0x1A)	/*  */
#define	CISTPL_CFTABLE_ENTRY	((UCHAR)0x1B)	/*  */
#define	CISTPL_DEVICE_CC		((UCHAR)0x1C)	/*  */
#define	CISTPL_DEVICE_OA		((UCHAR)0x1D)	/*  */
#define	CISTPL_DEVICEGEO		((UCHAR)0x1E)	/*  */
#define	CISTPL_DEVICEGEO_A		((UCHAR)0x1F)	/*  */

#define	CISTPL_MANFID			((UCHAR)0x20)	/*  */
#define	CISTPL_FUNCID			((UCHAR)0x21)	/*  */
#define	CISTPL_FUNCE			((UCHAR)0x22)	/*  */
#define	CISTPL_SWIL				((UCHAR)0x23)	/*  */

#define	CISTPL_VERS_2			((UCHAR)0x40)	/*  */
#define	CISTPL_FORMAT			((UCHAR)0x41)	/*  */
#define	CISTPL_GEOMETRY			((UCHAR)0x42)	/*  */
#define	CISTPL_BYTEORDER		((UCHAR)0x43)	/*  */
#define	CISTPL_DATE				((UCHAR)0x44)	/*  */
#define	CISTPL_BATTERY			((UCHAR)0x45)	/*  */
#define	CISTPL_ORG				((UCHAR)0x46)	/*  */
#define	CISTPL_FORMAT_A			((UCHAR)0x47)	/*  */

#define	CISTPL_SPCL				((UCHAR)0x90)	/*  */

#define	CISTPL_END				((UCHAR)0xFF)	/*  */


/******* CISTPL_DEVICE ******/
#define	DTYPE_MASK		((UCHAR)0xF0)
#define	DTYPE_NULL		((UCHAR)0x00)
#define	DTYPE_ROM		((UCHAR)0x10)
#define	DTYPE_OTPROM	((UCHAR)0x20)
#define	DTYPE_EPROM		((UCHAR)0x30)
#define	DTYPE_EEPROM	((UCHAR)0x40)
#define	DTYPE_FLASH		((UCHAR)0x50)
#define	DTYPE_SRAM		((UCHAR)0x60)
#define	DTYPE_DRAM		((UCHAR)0x70)

#define	DTYPE_FUNCSPEC	((UCHAR)0xD0)
#define	DTYPE_EXTEND	((UCHAR)0xE0)


#define	DSPEED_MASK		((UCHAR)0x07)
#define	DSPEED_NULL		((UCHAR)0x00)
#define	DSPEED_250NS	((UCHAR)0x01)
#define	DSPEED_200NS	((UCHAR)0x02)
#define	DSPEED_150NS	((UCHAR)0x03)
#define	DSPEED_100NS	((UCHAR)0x04)

#define	DSPEED_EXT		((UCHAR)0x07)


/******* CISTPL_VERS_1 ******/
#define	TPLLV1_MAJOR	0
#define	TPLLV1_MINOR	1
#define	TPLLV1_INFO		2


/******* CISTPL_FUNCID ******/
#define	TPLFID_FUNCTION	0
#define	TPLFID_SYSINIT	1

#define	TPLFID_MULTI_FUNCTION	((UCHAR)0x00)
#define	TPLFID_MEMORY			((UCHAR)0x01)
#define	TPLFID_SERIAL_PORT		((UCHAR)0x02)
#define	TPLFID_PARALLEL_PORT	((UCHAR)0x03)
#define	TPLFID_FIXED_DISK		((UCHAR)0x04)
#define	TPLFID_VIDEO_ADAPTER	((UCHAR)0x05)
#define	TPLFID_NETWORK_ADAPTER	((UCHAR)0x06)
#define	TPLFID_AIMS				((UCHAR)0x07)
#define	TPLFID_SCSI				((UCHAR)0x08)
#define	TPLFID_VENDOR_SPECIFIC	((UCHAR)0xFE)

/* bitfield */
#define	TPLFID_SYSINIT_POST	0x01	/* bit0: */
#define	TPLFID_SYSINIT_ROM	0x02	/* bit1: */


/******* CISTPL_FUNCE ******/
#define	TPLFE_TYPE	0
#define	TPLFE_UA	1
#define	TPLFE_UC	2

#define	TPLFE_TYPE_SERIAL_PORT_IF				((UCHAR)0x00)	/*  */
#define	TPLFE_TYPE_MODEM_IF						((UCHAR)0x01)	/*  */
#define	TPLFE_TYPE_DATA_MODEM					((UCHAR)0x02)	/*  */
#define	TPLFE_TYPE_FAX_MODEM					((UCHAR)0x03)	/*  */
#define	TPLFE_TYPE_VOICE_ENCORDING				((UCHAR)0x04)	/*  */
#define	TPLFE_TYPE_DATA_MODEM_IF				((UCHAR)0x05)	/*  */
#define	TPLFE_TYPE_FAX_MODEM_IF					((UCHAR)0x06)	/*  */
#define	TPLFE_TYPE_VOICE_MODEM_IF				((UCHAR)0x07)	/*  */
#define	TPLFE_TYPE_SERIAL_PORT_FOR_DATA_MODEM	((UCHAR)0x08)	/*  */
#define	TPLFE_TYPE_SERIAL_PORT_FOR_FAX_MODEM	((UCHAR)0x09)	/*  */
#define	TPLFE_TYPE_SERIAL_PORT_FOR_VOICE_MODEM	((UCHAR)0x0A)	/*  */



#endif /* _CISTUPLE_H_INCLUDED */
