/***********************************************************************
<t@C>	colpaint.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
***********************************************************************/

#ifndef _PAINT_TOOL
#define _PAINT_TOOL

#include <offscrn.h>
#include <dspclib.h>
#include <message.h>
#include <sndtool.h>

typedef enum TOOLNO{
	NONE_TOOL = 0,
	PEN_TOOL,
	ERASER_TOOL,
	LINE_TOOL,
	SELECT_TOOL,
	RECT_TOOL,
	FILL_TOOL,
	CIRCLE_TOOL,
	RULER_TOOL
} TOOLNO;

typedef enum FILTER{
	SOBEL = 0,
	SMOOTH,
	MEDIUM,
	SHARPEN
} FILTER;

typedef UCHAR	FONTSIZE;

typedef struct DOTTYPE{
	DOTSIZE		DotSize;		/* _TCY												*/
	DOTSHAPE	DotShape;		/* _`												*/
	DOTLABEL	DotLabel;		/* _`󃉃x											*/
} DOTTYPE;

typedef struct LINETYPE{
	LINEPAT		LineShape;		/* `												*/
	DOTTYPE		DotShape;		/* _`												*/
} LINETYPE;

typedef struct ATTRIBUTE{
	FILTER		FilterNo;		/* Filter ԍ											*/
	CDSPMODE	DispMode;		/* \[h											*/
	DOTTYPE		Pen;			/* M`												*/
	DOTTYPE		Eraser;			/* S`											*/
	LINETYPE	Line;			/* (For LINE_TOOL, RULER_TOOL)					*/
	LINETYPE	Rect;			/* (For RECT_TOOL)								*/
	PAINTPAT	FillMode;		/* hԂp^[									*/
	ICONMODE	IconMode;		/* ACR\[h									*/
	GCTABLESET	GCTableSet;		/* GCe[uZbgԍ									*/
	SCALEMODE	ScaleMode;		/* XP[[h										*/
	RESOURCE	Icon;			/* ACRf[^										*/
	int			LineP;			/* C|C^										*/
	UCHAR	   *String;			/* ͗p										*/	
	int			StrLen;			/* 												*/
	COLOR		BackColor;		/* wiF												*/
	COLOR		fg;				/* Foreground Color										*/
	COLOR		bg;				/* Background Color										*/
	POINT       sp;				/* Q_w̎n_										*/
	POINT		ep;				/* Q_w̏I_										*/
	RECTANGLE	OffscrnRect;	/* ItXN[`if[^ɑ΂鑊DotWj		*/
	RECTANGLE	LCDRect;		/* `͈͌`if[^ɑ΂鑊DotWj			*/
	USHORT		CharStep;		/* sb`											*/
	USHORT		LineStep;		/* ssb`												*/
} ATTRIBUTE;

typedef struct PAINTWORk{
	WINDOWHD	OffscrnHd;		/* OffScreen Handle										*/
	WINDOWHD  	CutBufferHd;	/* Cut Buffer p Offscreen Handle						*/
	WINDOWHD	MiniOffscrnHd;	/* depth=1  Offscreen Handle							*/
	WINDOWHD	TmpOffscrnHd;	/* Offscreen Handle for Rotate or Flip					*/
	WINDOWHD	WindowHd;		/* LCD Handle											*/
	WINDOWHD	RectHd;			/* DrawRectangle, DrawLine p Offscreen Handle			*/
	TOOLNO		ToolNo;			/* c[ԍ											*/
	UCHAR		PreCommandID;	/* R}hID											*/
	RECTANGLE	WindowRect;		/* `\̈											*/
	RECTANGLE	FrameMask;		/* t[}XN										*/
	RECTANGLE	rect;			/* f[^ǂݍݔ͈									*/
	RECTANGLE	mask;			/* f[^ǂݍݕsv͈								*/
	RECTANGLE	DragRect;		/* Drag & Drop  Drag n߂`̈					*/
	ATTRIBUTE	Attribute;		/* `摮												*/
	ATTRIBUTE	PreAttribute;	/* O`摮											*/
	POINT		scroll;			/* XN[(QP)										*/
	POINT		DrawOffset;		/* LCDɑ΂`ʒũItZbg						*/
	BOOLEAN		SelectFlag;		/* ͈͎w̗L										*/
	BOOLEAN		Editable;		/* ҏW\tO										*/
	BOOLEAN		StartFlag;
	BOOLEAN		ShrinkFlag;		/* k[h											*/
	BOOLEAN		InWindow;		/* X^[g|WVEBh or not				*/
	BOOLEAN		ClearFlag;		/* Move ̃NA										*/
	USHORT		width;			/* f[^												*/
	USHORT		height;			/* f[^											*/
	USHORT		depth;			/* F[x												*/
	USHORT		QP;				/* 𑜓xiʏQj										*/
	USHORT		Grid;			/* ObhTCY-1										*/
} PAINTWORK;

void	PaintObj(MESSAGE*, PAINTWORK*);

#define WindowWidth			320
#define WindowHeight		240

#define OffscrnWidth		(WindowWidth*1)
#define OffscrnHeight		(WindowHeight*1)

#define PaintEditDrawID					10000
#define PaintEditPressID				10001
#define PaintEditDrawEndID				10002
#define	PaintUndoID						10003
#define PaintDataWriteID				10004
#define PaintDataReadID					10005
#define PaintImageClearID				10006
#define PaintClearRectID				10007
#define PaintDispIconID					10008
#define	PaintMoveRectangleID			10009
#define PaintImageFilterID				10010
#define	PaintInitAttrID					10011
#define	PaintRotateCounterClockwiseID	10012
#define	PaintRotateClockwiseID			10013
#define	PaintUpSideDownID				10014
#define	PaintRightToLeftID				10015
#define PaintCopyMoveRectangleID		10016
#define PaintPasteOneDataID				10017

#define	NoneCommandID		0
#define	DrawPointID			1
#define	ErasePointID		2
#define DrawLineID			3
#define	DrawRectangleID		4
#define	FillRectangleID		5
#define	ClearRectangleID	6
#define	CutRectangleID		7
#define	PasteRectangleID	8
#define	DispCharsID			9
#define	DispIconID			10
#define	MoveRectangleID		11
#define	ImageFilterID		12
#define	PaintRotateID		13
#define	PaintFlipID			14
#define	CopyMoveRectangleID	15

void PointToRect(POINT*, POINT*, RECTANGLE*, USHORT);

#endif
