/***********************************************************************
<t@C>	crystal.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef _CRYSTAL_H
#define _CRYSTAL_H

#include <xtaltypes.h>

/***	Cxg̊Ǘp̌^̒`	*/

/* Cxg̉Z@ */
#define EVOP_REPLACE	0		/* result = value */
#define EVOP_SET	0		/* result = value */
#define EVOP_AND	1		/* result = old_value &  value */
#define EVOP_OR		2		/* result = old_value |  value */
#define EVOP_XOR	3		/* result = old_value ^  value */
#define EVOP_NAND	4		/* result = ~(old_value &  value) */
#define EVOP_NOR	5		/* result = ~(old_value |  value) */
#define EVOP_NXOR	6		/* result = ~(old_value ^  value) */
#define EVOP_ANDN	7		/* result = (~old_value) &  value */

#define EVCOND_AND	16		/* result = allBitAnd(event & mask) */
#define EVCOND_OR	17		/* result =  allBitOr(event & mask) */

struct Event_pbox{
	BYTE4	value;		/* Cxg̉Zl		*/
	BYTE4	mask;		/* Cxg̃}XN		*/
	BYTE4	op;		/* Cxg̉Z@		*/
	BYTE4	timeout;	/* ^CAEg鎞			*/
	BYTE4	result;		/* Cxg̏			*/
	OBJECT_NAME sender;	/* ŌɃCxgZbgvZX   */
	BYTE4  when;		/* ŌɃCxgZbgVXe */
};
#define EVENT_PBOX	struct Event_pbox

/* JoinedCxgmode */
#define JOEV_QWRITE	1
#define JOEV_QREAD	2
#define JOEV_SEM_SIGNAL	3
#define JOEV_SEM_WAIT	4



/***	Z}tH̊Ǘp̌^̒`	*/

struct Semaphore_pbox{
	OBJECT_NAME owner;	/* ݃Z}tHĂvZX */
	BYTE4 when;		/*݂ownerZ}tH𓾂̃VXe*/
};
#define SEMAPHORE_PBOX struct Semaphore_pbox

/***	Queue̊Ǘp̌^̒`	*/

struct Queue_pbox{
	UBYTE  *data;		/* f[^ւ̃|C^ */
	BYTE4  size;		/* f[^̃TCY */
	BYTE4  timeout;		/* ^CAEg̎ */
	OBJECT_NAME sender;	/* f[^̖̑O */
	BYTE4  when;		/* 傪f[^L[CÕVXe */
};
#define QUEUE_PBOX struct Queue_pbox


/***	vZX̊Ǘp̌^̒`	*/

/* struct Proc_info .type */
#define TASK		(0x01)		/* vZX */
#define THREAD		(0x02)		/* 񎞕vZX */
#define SYSTEM_THREAD	(0x12)		/* 񎞕vZX(SystemMode) */
#define SYSTEM_TASK	(0x11)		/* Task(SystemMode) X68K Only */

#define PROC_TASK_MASK	(0x0F)		/* Task/thread Mask */
#define PROC_MODE_MASK	(0xF0)		/* Sys/User Mask */

struct Proc_ini{
	BYTE4		type;		/* thread or Task */
	BYTE4		priority;	/* Dxl */
	OBJECT_NAME	code;		/* vOR[h */
	BYTE4		stack_size;	/* X^bNTCY */
	OBJECT_NAME	data;		/* f[^̈於 */
	OBJECT_NAME	message;	/* vZẌ(Debugp)*/
};
#define PROC_INI	struct Proc_ini

/***	dbg_reg_put(), dbg_reg_get()̃WX^̒`	*/
#define REG_R0		0
#define REG_R1		1
#define REG_R2		2
#define REG_R3		3
#define REG_R4		4
#define REG_R5		5
#define REG_R6		6
#define REG_R7		7
#define REG_R8		8
#define REG_R9		9
#define REG_R10		10
#define REG_R11		11
#define REG_R12		12
#define REG_R13		13
#define REG_R14		14
#define REG_R15		15
#define REG_SP		15

#define REG_SR		16
#define REG_GBR		17
#define REG_MACH	18
#define REG_MACL	19
#define REG_PR		20
#define REG_PC		21

/***	error number	*/

#define ERR_PAGEFAULT	0x80000000
#define ERR_TLB_MISS		0
#define ERR_TLB_MISS_DATA	1
#define ERR_TLB_MISS_STACK	2
#define ERR_TLB_MISS_DOWNLOAD	3
#define ERR_TLB_MISS_WINDOW	4
#define ERR_INIT_PAGE_WRITE	5
#define ERR_TLB_PROTECT_READ	6
#define ERR_TLB_PROTECT_WRITE	7
#define ERR_ADDRESS_ERROR_READ	8
#define ERR_ADDRESS_ERROR_WRITE	9
#define ERR_MEMORY_EXHAUST	10

/***** System Call procedures *****/


/* VXe */

BYTE4 sys_gettime();
/*
	BYTE4 sys_gettime()

	VXeԂԂ
*/


OBJECT_NAME name_generate();

int code_create();
int code_delete();


/* vZX */

int proc_create();
/*
	int proc_create(name, pdata)
	OBJECT_NAME name;
	PROC_INI *pdata;
	Ԃl	G[̎́|PԂ
		nameNAME_UNIQUE̎͐ꂽOԂ

	vZX쐬
	vZXԂEXIST
*/


int proc_delete();
/*
	int proc_delete(name)
	OBJECT_NAME name;

	vZX폜
	G[̎́|PԂ
*/


int proc_start();
/*
	int proc_start(name)
	OBJECT_NAME name;

	vZXԂEXISTREADYɈڍs
	G[̎́|PԂ
*/


int proc_stop();
/*
	int proc_stop(name)
	OBJECT_NAME name;

	vZXԂEXISTԂɂ
	G[̎́|PԂ
*/



int proc_wakeup();
/*
	int proc_wakeup(name)
	OBJECT_NAME name;

	vZXԂSLEEPREADYԂɈڍs
	G[̎́|PԂ
*/


int proc_sleep();
/*
	int proc_sleep(name,timeout)
	OBJECT_NAME name;
	BYTE4 timeout;

	vZXԂSLEEPԂɂ
	G[̎́|PԂ
*/


int proc_setslice();
int proc_setpriority();

int self_sleep();
/*
	int self_sleep(timeout)
	BYTE4 timeout;

	SLEEPԂɂ
	G[̎́|PԂ
*/


void self_end();
/*
	int self_end()

	vZX
	^[܂
*/


OBJECT_NAME self_getname();
/*
	OBJECT_NAME
	self_getname()

	vZX̖OԂ
	G[̂Ƃ-1
*/


int self_setslice();
int self_setpriority();
int self_grab_cpu();
int self_ungrab_cpu();


BYTE4 proc_get_lifetime();
/*
	BYTE4 proc_get_lifetime(name)
	OBJECT_NAME name;

	vZX̎𒲂ׂ
	G[̎́|PԂ
*/


BYTE4 self_get_lifetime();
/*
	BYTE4 self_get_lifetime()

	vZX̎𒲂ׂ
	G[̎́|PԂ
*/



/* L[ */


int queue_create();
/*
	int queue_create(name, len, data_max_size)
	OBJECT_NAME name;
	BYTE4 len;
	BYTE4 data_max_size;
	Ԃl	G[̎́|PԂ
		nameNAME_UNIQUE̎͐ꂽOԂ

		len L[̒
		data_max_size L[̈f[^TCY

	L[쐬
*/


int queue_delete();
/*
	int queue_delete(name)
	OBJECT_NAME name;

	L[폜
	G[̎́|PԂ
*/


int queue_read();
/*
	int queue_read(name, pbox)
	OBJECT_NAME name;
	QUEUE_PBOX *pbox;
	Ԃl 펞O

	L[f[^ǂݏo
	G[̎́|PԂ
	^CAEg̎́|QԂ
*/


int queue_write();
/*
	int queue_write(name, pbox)
	OBJECT_NAME name;
	QUEUE_PBOX *pbox;
	Ԃl 펞O

	L[Ƀf[^
	G[̎́|PԂ
	^CAEg̎́|QԂ
*/


int queue_peek();
/*
	int queue_peek(name)
	OBJECT_NAME name;

		Ԃl L[ɂf[^TCY

	L[Ƀf[^TCY𒲂ׂ
	f[^Ȃ͂OԂ
	G[̎́|PԂ
*/


int queue_npeek();
/*
	int queue_npeek(name)
	OBJECT_NAME name;

		Ԃl L[ɂf[^TCY

	L[Ƀf[^TCY𒲂ׂ
	G[̎́|PԂ
*/



/* Cxg */



int event_create();
/*
	int event_create(name)
	OBJECT_NAME name;
	Ԃl	G[̎́|PԂ
		nameNAME_UNIQUE̎͐ꂽOԂ

		name	Cxg

	Cxg쐬
*/


int event_delete();
/*
	int event_delete(name)
	OBJECT_NAME name;

		name	Cxg

	Cxg폜
	G[̎́|PԂ
*/


BYTE4 event_get();
/*
	BYTE4 event_get(name)
	OBJECT_NAME name;

		name	Cxg

	Cxg̒lǂݏoiCxg̒l͕ωȂj
	G[̎́|PԂ
*/


int event_set();
/*
	int event_set(name,pbox)
	OBJECT_NAME name;
	EVENT_PBOX *pbox;

		name	Cxg
		*pbox	Cxgݒ̈
			value,opɂĉZs܂
			mask,reset_value,reset_op,timeout͎g܂
			Zʂ̃CxglflagsɊi[܂

	CxgɃZbg
	G[̎́|PԂ
*/


int event_wait();
/*
	int event_wait(name,pbox)
	OBJECT_NAME name;
	EVENT_PBOX *pbox;

		name	Cxg
		*pbox	Cxg҂̈
			mask̒lŃCxg̒lɃ}XN|
			value,opɂĉZšʂOɂȂ
			҂Ԃ甲܂
			҂Ԃ甲鎞ACxgɑ΂reset_valueAreset_op
			̉Zs܂BA^CAEgɂ͍s܂

	Cxg҂܂
	G[̎́|PԂ
*/




/* Z}tH */

int semaphore_create();
/*
	int semaphore_create(name)
	OBJECT_NAME name;
	Ԃl	G[̎́|PԂ
		nameNAME_UNIQUE̎͐ꂽOԂ

	Z}tH쐬
*/


int semaphore_delete();
/*
	int semaphore_delete(name)
	OBJECT_NAME name;

	Z}tH폜
	G[̎́|PԂ
*/


int semaphore_wait();
/*
	int semaphore_wait(name,timeout,pbox)
	OBJECT_NAME name;
	BYTE4 timeout;
	SEMAPHORE_PBOX *pbox;		NULL͖̎܂

	Z}tH𓾂
	G[̎́|PԂ
	^CAEg̎́|QԂ pboxɏԂ
*/


int semaphore_signal();
/*
	int semaphore_signal(name)
	OBJECT_NAME name;

	Z}tHJ
	G[̎́|PԂ
*/



/* O */



OBJECT_NAME str_to_name();
/*
	OBJECT_NAME str_to_name(str)
	char *str;
	Ԃl		O

	񂩂疼Oɕϊ
*/



void name_to_str();
/*
	void name_to_str(str,name)
	char *str;
	OBJECT_NAME name;

	O當ɕϊ
*/



int name_byte();
/*
	int name_byte(byte,name)
	unsigned char *byte;
	OBJECT_NAME name;

	OoCgɕϊẴTCYԂ
*/


int byte_name();
/*
	int str_name(name,byte)
	OBJECT_NAME *name;
	unsigned char *byte;
	
	oCg𖼑OɕϊẴTCYԂ
*/



/***************************************************************************/


int kernel_init();
/*
	int kernel_init(name,pdata)
	OBJECT_NAME name;		vZX
	PROC_INI *pdata;		vZX

	J|l̏s
	G[̎́|PԂ
*/


int name_info();
/*
	int name_info(name,info)
	OBJECT_NAME name;
	OBJECT_INFO *info;

	OɊւǂݏo
	OȂ́|PԂ
*/




int name_list_first();
/*
	int name_list_first(info)
	NAME_INFO_LIST *info;
	Ԃl@|P̂ƂׂĂ̖OɊւo͂

	ׂĂ̖Ȍo
	@@name_list_next()ƃZbgŎg
*/

int name_list_next();
/*
	int name_list_next(info)
	NAME_INFO_LIST *info;
	Ԃl@|P̂ƂׂĂ̖OɊւo͂

	ׂĂ̖Ȍo

	@@name_list_next()AŌĂтĈo
	@@Aڂ̌ďoname_list_first()ƂAinfo͖
	@@̂nȂ΂ȂȂ
*/


/****************************************************************************/


int memory_create();
/*
	int memory_create( name, size )
	OBJECT_NAME name;
	BYTE4 size;		mۂTCY(byte)
	Ԃl		G[̂Ƃ|PԂ
			nameNAME_UNIQUE̎͐ꂽOԂ

	mۂ
*/



int memory_delete();
/*
	int memory_delete( name )
	OBJECT_NAME name;
	Ԃl		G[̎|PԂ܂

	܂
*/

BYTE *memory_address();
/*
	BYTE *memory_address( name )
	OBJECT_NAME name;
	Ԃl		G[̂ƂNULL

	nameɊmۂĂÃAhXԂ
*/

BYTE4 memory_getsize();
/*
	BYTE4 memory_getsize( name )
	OBJECT_NAME name;
	Ԃl		G[̂Ƃ-1

	nameɊmۂĂÃTCYԂ
*/

/****************************************************************************/

int intrev_create();
/*
	int
	intrev_create( name, event )
	OBJECT_NAME name, event;
	Ԃl G[̎́|P
*/

int intrev_delete();
/*
	int
	intrev_delete( name )
	OBJECT_NAME name;
	Ԃl G[̎|PԂ
*/

int intrev_set();
/*
	int
	intrev_set( name )
	OBJECT_NAME name;
	Ԃl G[̎́|PԂ

	CxgtO̐ݒ
*/


/***************************************************************************/

void dbg_putstr();
void dbg_write();
void object_dbgdump();

/***************************************************************************/


int db_puts();
/*
	int db_puts( str )
	char *str;

	\
*/

int db_puts_scr();	/* eXgp */

#endif _CRYSTAL_H
