/***********************************************************************
<t@C>	cs_util.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		J[hT[rXg₷邽߂֗̕ 
***********************************************************************/

#ifndef _CS_UTIL_H_INCLUDED
#define _CS_UTIL_H_INCLUDED

#include <sharpgen.h>
#include <cardsvc.h>

/***********************************************************************
			CIS Tuple TutB[h`
***********************************************************************/


/** CISTPL_CFTABLE_ENTRY **/
#define	TPCE_INDX_CONFIG_ENTRY_NO_MASK	0x3f
#define	TPCE_INDX_DEFAULT				0x40
#define	TPCE_INDX_INTFACE				0x80

#define	TPCE_IF_MEMORY			0x00	/*  */
#define	TPCE_IF_IO_AND_MEMORY	0x01	/*  */
#define	TPCE_IF_CUSTOM_IF0		0x04	/*  */
#define	TPCE_IF_CUSTOM_IF1		0x05	/*  */
#define	TPCE_IF_CUSTOM_IF2		0x06	/*  */
#define	TPCE_IF_CUSTOM_IF3		0x07	/*  */
#define	TPCE_IF_BVDs_ACTIVE		0x10	/*  */
#define	TPCE_IF_WP_ACTIVE		0x20	/*  */
#define	TPCE_IF_READY_ACTIVE	0x40	/*  */
#define	TPCE_IF_M_WAIT_REQUIRED	0x80	/*  */

#define	TPCE_FS_POWER_NONE			0x00
#define	TPCE_FS_POWER_VCC_ONLY		0x01
#define	TPCE_FS_POWER_VCC_VPP		0x02	/* Vpp1 = Vpp2 */
#define	TPCE_FS_POWER_VCC_VPP1_VPP2	0x03	
#define	TPCE_FS_POWER_MASK			0x03
#define	TPCE_FS_TIMING				0x04
#define	TPCE_FS_IO_SPACE			0x08
#define	TPCE_FS_IRQ					0x10
#define	TPCE_FS_MISC				0x80

#define	TPCE_MI_MAX_TWIN_CARDS_MASK	0x07	/*  */
#define	TPCE_MI_AUDIO				0x08	/*  */
#define	TPCE_MI_READ_ONLY			0x10	/*  */
#define	TPCE_MI_PWR_DOWN			0x20	/*  */
#define	TPCE_MI_EXT					0x80	/*  */


/***********************************************************************
			Cu֐p ^錾
***********************************************************************/


/*--------------------------------------------------------------------*/
#define	PRESENCE_MASK_LEN	16
#define	SUBTUPLES_LEN		16

typedef struct CISINFO_CONFIG {
	UBYTE	LastIndex;
	UBYTE	no_use1;
	UBYTE	no_use2;
	UBYTE	no_use3;
	ULONG	Base;
	UBYTE	PresenceMask[PRESENCE_MASK_LEN];
} CISINFO_CONFIG;


/*--------------------------------------------------------------------*/

/* I/OEBhE̐ݒԂ\킷^ */
/* PI-6̏ꍇARg[̐݌vAȉ̃Gg̍̂l͌Œ肳 */
/*	stat == cOn				 */
/*	cIoWinOffs <= HostAdr <= cIoWinOffs + 0x01ffffff */
/*	0x00000000 <= cardAddr <= 0x01ffffff	 */
/*	0x00000000 <= size <= 0x02000000	 */
typedef struct CSCNF_IOWIN {
	UBYTE	Width;		/* I/OEBhEANZX */
	ACCSPD	Speed;		/* I/OEBhEANZXxݒ */
	ULONG	CardAdr;	/* PCJ[h̃AhX */
	ULONG	HostAdr;	/* I/OEBhẼAhX */
	ULONG	Size;		/* I/OEBhẼTCY */
} CSCNF_IOWIN;


/* EBhE̐ݒԂ\킷^ */
/* PI-6̏ꍇARg[̐݌vAȉ̃Gg̍̂l͌Œ肳 */
/* win#0̏ꍇ					*/
/*	cMemWinOffs  <= HostAdr <= cMemWinOffs + 0x01ffffff */
/*	size == 0x02000000			*/
typedef struct CSCNF_MEMWIN {
	ACCSPD	Speed;		/* EBhEANZXxݒ */
				/*			(cSpd...) */
	UBYTE	Area;		/* PCJ[h̃ (cArea...) */
	ULONG	CardAdr;	/* PCJ[h̃AhX */
	ULONG	HostAdr;	/* EBhẼAhX */
	ULONG	Size;	/* ݒ肳ꂽEBhẼTCY */
} CSCNF_MEMWIN;

#define CSCNF_IOWIN_NO	4
#define	CSCNF_MEMWIN_NO	4

/* IFMt@NVp : RtBM[VGg̎擾 */
typedef struct CISINFO_CFTABLE_ENTRY {
	UBYTE	Index;		/* r:CfbNXԍ */
	UBYTE   Voltages; /* ADD 10/17/95 by O.Nishida */
	UBYTE   Vcc;
	UBYTE   Vpp1;
	UBYTE   Vpp2;
	UBYTE	IrqType;	/* r:IRQ̃^Cv (cIrqType...) */
	UBYTE	IONum;		/* r:I/OEBhE */
	UBYTE	MemNum;		/* r:EBhE */
	CSCNF_IOWIN		IOWin[CSCNF_IOWIN_NO];		/* r:I/OEBhEݒl */
	CSCNF_MEMWIN	MemWin[CSCNF_MEMWIN_NO];	/* r:EBhEݒl */
} CISINFO_CFTABLE_ENTRY;

/** .Voltages(bitfield) **/
#define	VALID_VCC	0x01
#define	VALID_VPP1	0x02
#define	VALID_VPP2	0x04

/** .IOWin.Width **/
#define	IO_DATA_WIDTH8		0x01	/* 8bit I/OoX */
#define	IO_DATA_WIDTH16		0x02	/* 16bit I/OoX */
#define	IO_DATA_WIDTH816	0x03	/* IOCS16MVXeoXɒʂ */

/** .IRQType(bitfield) **/
#define	IRQ_TYPE_NONE	0x00	/* l */
#define	IRQ_TYPE_LEVEL	0x01	/* bit0='1': x荞݂gpł */
#define	IRQ_TYPE_PULSE	0x02	/* bit1='1': pX荞݂gpł */


/*--------------------------------------------------------------------*/

typedef struct CISINFO_VERS1 {
	UCHAR	MajorRevNo;						/* Major Revision Number */
	UCHAR	MinorRevNo;						/* Minor ... */
	PCCARDNAME	Info;
} CISINFO_VERS1;


/***********************************************************************
			Cu֐vg^Cv錾
***********************************************************************/

CS_RESULT ParseConfigTuple( CISINFO_CONFIG *pInfo, UCHAR *pTupleData );
CS_RESULT ParseCfTableEntryTuple ( CISINFO_CFTABLE_ENTRY *pInfo,
								   UCHAR *pTupleData );
CS_RESULT ParseL1VerProductInfoTuple( CISINFO_VERS1 *pInfo,
									  UCHAR *pTupleData );


#endif /* #ifndef _CS_UTIL_H_INCLUDED */

