/*
		      ANSI C Runtime Library

    Copyright 1983,1984,1985,1986,1987,1988,1989,1990,1991,1992,1993,1994,1995
		    Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

#ifndef _FLOAT_H
#define _FLOAT_H
#define FLT_RADIX       2
#define FLT_ROUNDS      1	/* most systems implement round to nearest */

#if defined(__IeeeFloat)

#define FLT_MANT_DIG    (24)
#define FLT_EPSILON     (1.1920929e-7f)
#define FLT_DIG         (6)
#define FLT_MIN_EXP     (-125)
#define FLT_MIN         (1.175494350822287508e-38f)
#define FLT_MIN_10_EXP  (-37)
#define FLT_MAX_EXP     (128)
#define FLT_MAX         (3.40282347e+38f)
#define FLT_MAX_10_EXP  (38)

#define DBL_MANT_DIG    (53)
#define DBL_EPSILON     (2.2204460492503131e-16)
#define DBL_DIG         (15)
#define DBL_MIN_EXP     (-1021)
#define DBL_MIN         (2.2250738585072015e-308)
#define DBL_MIN_10_EXP  (-307)
#define DBL_MAX         (1.7976931348623157e+308)
#define DBL_MAX_EXP     (1024)
#define DBL_MAX_10_EXP  (308)

/* the standard explicitly says that long double is IEEE 80bit extended type */
/* if IEEE is used.  we do not conform to that yet */
#define LDBL_MANT_DIG   DBL_MANT_DIG
#define LDBL_EPSILON    DBL_EPSILON
#define LDBL_DIG        DBL_DIG
#define LDBL_MIN_EXP    DBL_MIN_EXP
#define LDBL_MIN        DBL_MIN
#define LDBL_MIN_10_EXP DBL_MIN_10_EXP
#define LDBL_MAX        DBL_MAX
#define LDBL_MAX_EXP    DBL_MAX_EXP
#define LDBL_MAX_10_EXP DBL_MAX_10_EXP

#elif defined(__VaxFloat)

#define FLT_MANT_DIG    23
#define FLT_EPSILON     1e-7f
#define FLT_DIG         7
#define FLT_MIN_EXP     -126
#define FLT_MIN         1e-37f
#define FLT_MIN_10_EXP  -37
#define FLT_MAX_EXP     126
#define FLT_MAX         1e+37f
#define FLT_MAX_10_EXP  37

#define DBL_MANT_DIG    55
#define DBL_EPSILON     1e-17
#define DBL_DIG         16
#define DBL_MIN_EXP     -126
#define DBL_MIN         1e-37
#define DBL_MIN_10_EXP  -37
#define DBL_MAX_EXP     126
#define DBL_MAX         1e+37
#define DBL_MAX_10_EXP  37

#define LDBL_MANT_DIG   56
#define LDBL_EPSILON    1e-17
#define LDBL_DIG        16
#define LDBL_MIN_EXP    -126
#define LDBL_MIN        1e-37
#define LDBL_MIN_10_EXP -37
#define LDBL_MAX_EXP    126
#define LDBL_MAX        1e+37
#define LDBL_MAX_10_EXP 37

#else
#error   Neither IEEE or Vax Floating point defined.  This is very bad.
#endif

#endif  /* _FLOAT_H */
