/***********************************************************************
<t@C>	irnetlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		lbg[NhCoIOCS
		CuɊւ`
***********************************************************************/

#ifndef _IRNET_H_INCLUDED
#define _IRNET_H_INCLUDED

#include <sharpgen.h>
#include <comdvlib.h>
/* #include <irbcomlb.h> */
#include <abort.h>
#include <ioercode.h>


/*======================================================================
	G[R[h
======================================================================*/

#define	EC_IRNET_BAD_WORK_PTR			(IRNET_EC_BASE+0x0001)
#define	EC_IRNET_COMM_SPACE_BUSY		(IRNET_EC_BASE+0x0002)
#define	EC_IRNET_HARD_ERROR				(IRNET_EC_BASE+0x0003)
#define	EC_IRNET_RCV_TIMEOUT			(IRNET_EC_BASE+0x0004)
#define	EC_IRNET_ABORTED				(IRNET_EC_BASE+0x0005)
#define	EC_IRNET_RECEIVE_TIRED			(IRNET_EC_BASE+0x0006)
#define	EC_IRNET_RECEIVE_ERROR			(IRNET_EC_BASE+0x0007)
#define	EC_IRNET_SEND_PACKET_TOO_LARGE	(IRNET_EC_BASE+0x0008)
#define	EC_IRNET_TP_RCVBUF_OVER			(IRNET_EC_BASE+0x0009)
#define	EC_IRNET_TP_RCV_PACKET_LOST		(IRNET_EC_BASE+0x000a)


typedef int IRNETERR;		/* G[R[h */
typedef int IRNETRCVLEN;	/* >=0:Mf[^̒ or <0:G[R[h */

typedef unsigned short IRNETSUM;



/*======================================================================
	[N
======================================================================*/

#ifndef H2EQU

typedef unsigned long IRNETADR;

typedef struct IRNETWORK {
	USHORT		WorkSize;
	USHORT		Type;		/* lbg[NvgR^Cv */
	COMMDEVNAME	DevName;
	COMMDEV		*pDev;
/*	IrBCOM		*pIrBCom; */	void		*pIrBCom;
	ABORTMASK	AbortMask;
	ULONG		LastRcvTime;
} IRNETWORK;



/*======================================================================
	Cu֐̈ or ߂l
======================================================================*/

/* OpenIRNetwork( xxx, Type ) */
#define	IRNET_TYPE_SHARP		0x00


/* LookStateIRNetDL()̖߂l */
typedef long IRNETSTATE;
#define	IRNETST_RECEIVE_PREAMPLE	0x00000001	/* bit0: preample M */
/* bit30`1 \ */
#define	IRNETST_ABORTED				0x80000000	/* bit31:f */




#define	IRNET_ADR_ALL		0xffffffff
#define	IRNET_ADR_UNKNOWN	0xfffffffe


/* SendIRNetNT( , xxx ) */
/* Mvp[^ */
typedef struct IRNETSEND_NT {
	IRNETADR	SenderAdr;		/* ̃AhX */
	IRNETADR	ListenerAdr;	/* 󂯎̃AhX */
	const void	*pSendData;		/* f[^̃AhX */
	ULONG		DataLen;		/* *pSendData̒iPpPbgj*/
} IRNETSEND_NT;

/* ReceiveIRNetNT()ԂMpPbg */
/*  */
typedef struct IRNETRCVINFO_NT {
	IRNETADR	SenderAdr;		/*iMpPbǵj̃AhX */
	IRNETADR	ListenerAdr;	/*iMpPbǵj󂯎̃AhX */
	void		*pBuf;			/* Mf[^i[Ă擪adr */
	ULONG		Len;			/* *pBuf̓e̒ */
	ULONG		Rsv[4];			/* gpi\j*/
} IRNETRCVINFO_NT;



/* SendIRNetTP( ,xxx ) */
/* Mvp[^ */
typedef struct IRNETSEND_TP {
	IRNETADR	SenderAdr;		/* ̃AhX */
	IRNETADR	ListenerAdr;	/* 󂯎̃AhX */
	UCHAR		TransInfo;		/* ] */
	UCHAR		SessionID;		/* ZbV̎ */
	UCHAR		Reserved[2];	/* \iKOj */
	const void	*pSendData;		/* f[^̃AhX */
	ULONG		DataLen;		/* *pSendData̒ */
} IRNETSEND_TP;

/*** .TransInfo bit3`0̂ݎgp\ibit7`4͕KOj */
#define	IRNET_TPINFO_CODED		 0x08  /* bit3=1: Í */
#define	IRNET_TPINFO_CENTER_STA	 0x04  /* bit2=1: Center Sta.M */
#define	IRNET_TPINFO_NETWORK_STA 0x02  /* bit1=1: Network Sta.M */
/* bit0 \iKOj */

/*** .SessionID ***/
#define	IRNET_SSID_MAIL		0x01
#define	IRNET_SSID_NETWORK	0x02	/* ʏihȂǁj */


/* ReceiveIRNetNT()ԂMpPbg */
/*  */
typedef struct IRNETRCV_TP {
	IRNETADR	SenderAdr;	/* (r)iMpPbǵj̃AhX */
	IRNETADR	ListenerAdr;/* (r)iMpPbǵj󂯎̃AhX */
	UCHAR		TransInfo;	/* (r) ] */
	UCHAR		DataKind;	/* (r) f[^̎ */
	UCHAR		SessionID;	/*(P) ZbV̎ */
	UCHAR		BlockID;	/* (r) ubNԍ */
	void		*pBufTop;	/*(P) Mf[^i[Ă擪adr */
	ULONG		BufLen;		/*(P) *pBuf̓e̒ */
	ULONG		RcvLen;		/* (r) M    */
	ULONG		Rsv[4];		/*    gpi\j*/
							/*(P):p[^ƂĐݒ肷ׂ  */
							/*  (r):߂l */
} IRNETRCV_TP;

#endif H2EQU


/*======================================================================
	Cu֐vg^Cv錾
======================================================================*/

/* main */
int InitIRNetwork( int ResetLevel );
USHORT GetVerIRNetwork( void );
IRNETWORK *OpenIRNetwork( COMMDEVNAME name, USHORT Type );
int CloseIRNetwork( IRNETWORK *pIrNet );

/* f[^Nw */
int SendIRNetDL( IRNETWORK *pIrNet, const char *pSendData, ULONG DataLen );
IRNETSTATE LookStateIRNetDL( IRNETWORK *pIrNet );
int ReceiveIRNetDL( IRNETWORK *pIrNet, char *pRcvBuf, ULONG BufLen );

/* lbg[Nw */
IRNETSTATE LookStateIRNetNT( IRNETWORK *pIrNet );
IRNETERR SendIRNetNT( IRNETWORK *pIrNet, IRNETSEND_NT *pReq );
IRNETRCVLEN ReceiveIRNetNT( IRNETWORK *pIrNet, void *pBuf, ULONG BufLen,
						    IRNETRCVINFO_NT *pInfo );

/* gX|[gw */
IRNETSTATE LookStateIRNetTP( IRNETWORK *pIrNet );
IRNETERR SendIRNetTP( IRNETWORK *pIrNet, IRNETSEND_TP *pReq );
IRNETERR RcvOneSSIRNetTP( IRNETWORK *pIrNet, IRNETRCV_TP *pReqRes );


/*======================================================================
	IOCSt@NVԍ
======================================================================*/

#define	INIT_IR_NETWORK			0x40
#define	GET_VER_IR_NETWORK		0x41
#define	OPEN_IR_NETWORK			0x42
#define	CLOSE_IR_NETWORK		0x43

/* f[^Nw */
#define	LOOK_STATE_IR_NET_DL	0x48
#define	SEND_IR_NET_DL			0x49
#define	RECEIVE_IR_NET_DL		0x4a

/* lbg[Nw */
#define	LOOK_STATE_IR_NET_NT	0x50
#define	SEND_IR_NET_NT			0x51
#define	RECEIVE_IR_NET_NT		0x52

/* gX|[gw */
#define	LOOK_STATE_IR_NET_TP	0x58
#define	SEND_IR_NET_TP			0x59
#define	RCV_ONE_SS_IR_NET_TP	0x5a


#endif /* #ifndef _IRNET_H_INCLUDED */


