/***********************************************************************
<t@C>	sndtool.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		TEhc[`
***********************************************************************/
#ifndef SNDTOOL_H_INCLUDED
#define	SNDTOOL_H_INCLUDED
#include <sharpgen.h>
#include <fclib.h>

/* t@NVԍ */
#define	PLAY_EFFECT_BY_SND_NO	0x41
#define	PLAY_EFFECT_BY_FILE		0x42
#define	PLAY_ALERT_BY_SND_NO	0x43
#define	PLAY_ALERT_BY_FILE		0x44
#define	PLAY_ALARM_BY_SND_NO	0x45
#define	PLAY_ALARM_BY_FILE		0x46
#define	SET_SOUND_VOLUME		0x47
#define	GET_SOUND_VOLUME		0x48
#define	SER_FILE_ANY_DRIVE		0x49

#define	SNDTOOL_LAST_FUNC	SER_FILE_ANY_DRIVE

/* VXeTEhID(1-) */
#define	SYS_START_SND		1
#define	SYS_KEYDOWN_SND		2
#define	SYS_BTNDOWN_SND		3
#define	SYS_ALERT1_SND		4
#define	SYS_ALERT2_SND		5
#define	SYS_JIHO_SND		6
#define	SYS_ALARM0_SND		7
#define	SYS_ALARM1_SND		8
#define	SYS_ALARM3_SND		9
#define	SYS_ALARM4_SND		10
#define	SYS_LOWBAT_SND		11
#define	SYS_SUMMER_SND		12
#define	SYS_CAMERA_SND		13
#define	SYS_PAD_SND			14
#define	SYS_CALCPAD_SND		15
#define	SYS_PAINT_SND		16
#define	SYS_ATTACH_SND		17
#define	SYS_OUTBOX_SND		18
#define	SYS_FINDER_SND		19
#define	SYS_IBOOK_SND		20
#define	SYS_GETBOOK_SND		21
#define	SYS_OPNBOOK_SND		22
#define	SYS_OPNIDX_SND		23
#define	SYS_CLSIDX_SND		24
#define	SYS_MAIL_SND		25
#define	SYS_SCROLL_SND		26
#define	SYS_PAGE_SND		27
#define	SYS_HANDPAD_SND		28
#define	SYS_STD_SND			29
#define	SYS_NOPBTN_SND		30
#define	SYS_NULL_SND		31

/* TEh */
typedef enum SOUNDTYPE {
	TOUCH_SOUND	= 1,
	EFFECT_SOUND,
	ALERT_SOUND,
	OPENING_SOUND,
	ALARM_SOUND,
	CHIME_SOUND,
	CAMERA_SOUND,
	DALARM_SOUND
} SOUNDTYPE;

/* }N */
#define	PlaySysTouch(s)		PlayEffectBySndNo(TOUCH_SOUND,s)
#define	PlayTouch(f)		PlayEffectByFile(TOUCH_SOUND,f)
#define	PlaySysEffect(s)	PlayEffectBySndNo(EFFECT_SOUND,s)
#define	PlayEffect(f)		PlayEffectByFile(EFFECT_SOUND,f)
#define	PlaySysCamera(s)	PlayEffectBySndNo(CAMERA_SOUND,s)
#define	PlayCamera(f)		PlayEffectByFile(CAMERA_SOUND,f)
#define	PlaySysAlert(s)		PlayAlertBySndNo(ALERT_SOUND,s)
#define	PlayAlert(f)		PlayAlertByFile(ALERT_SOUND,f)
#define	PlaySysOpening(s)	PlayAlertBySndNo(OPENING_SOUND,s)
#define	PlayOpening(f)		PlayAlertByFile(OPENING_SOUND,f)
#define	PlaySysAlarm(s)		PlayAlarmBySndNo(ALARM_SOUND,s)
#define	PlayAlarm(f)		PlayAlarmByFile(ALARM_SOUND,f)
#define	PlaySysDAlarm(s)	PlayAlarmBySndNo(DALARM_SOUND,s)
#define	PlayDAlarm(f)		PlayAlarmByFile(DALARM_SOUND,f)
#define	PlaySysChime(s)		PlayAlertBySndNo(CHIME_SOUND,s)
#define	PlayChime(f)		PlayAlertByFile(CHIME_SOUND,f)
#define	PlayBeep()			PlayAlertBySndNo(ALERT_SOUND,SYS_ALERT1_SND)

/* ֐錾 */
void PlayEffectBySndNo(SOUNDTYPE SoundType,UCHAR SysSoundID);
void PlayEffectByFile(SOUNDTYPE SoundType,STRING SoundFName);
void PlayAlertBySndNo(SOUNDTYPE SoundType,UCHAR SysSoundID);
void PlayAlertByFile(SOUNDTYPE SoundType,STRING SoundFName);
void PlayAlarmBySndNo(SOUNDTYPE SoundType,UCHAR SysSoundID);
void PlayAlarmByFile(SOUNDTYPE SoundType,STRING SoundFName);
void SetSoundVolume(SOUNDTYPE Type,int Volume);
int GetSoundVolume(SOUNDTYPE Type);
BOOLEAN SearchFileInAnyDrive(FCFNAME *ResultFName,
							 STRING TargetFName);
#endif
