/*
		      ANSI C Runtime Library

	Copyright 1983-1996 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/
#ifndef _STRING_H
#define _STRING_H
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__cplusplus) && !defined(NULL)
#define NULL 0L		/* C++ requires this to be integral, not a pointer */
#elif !defined(NULL)
#define NULL ((void *)0)/* locale.h stddef.h stdio.h stdlib.h string.h time.h */
#endif

#ifndef _SIZE_T
#define _SIZE_T
# if defined(__Ptr_Is_64) && !defined(__Int_Is_64)
typedef unsigned long size_t;
# else
typedef unsigned int size_t;
# endif
#endif	/* _SIZE_T */

#if defined(__STDC__) || defined(__cplusplus)
#define __ARGS(x)		x
#define __VOIDPTR		void
#elif defined(__PROTOTYPES__)
#define __ARGS(x)		x
#define __VOIDPTR		char
#else
#define __ARGS(x)		()
#define __VOIDPTR		char
#endif

__VOIDPTR *memchr  __ARGS((const void *, int, size_t));
__VOIDPTR *memcpy  __ARGS((void *, const void *, size_t));
__VOIDPTR *memmove __ARGS((void *, const void *, size_t));
__VOIDPTR *memset  __ARGS((void *, int, size_t));

char *strcat  __ARGS((char *, const char *));
char *strncat __ARGS((char *, const char *, size_t));
char *strchr  __ARGS((const char *, int));
char *strrchr __ARGS((const char *, int));
char *strcpy  __ARGS((char *, const char *));
char *strncpy __ARGS((char *, const char *, size_t));
char *strpbrk __ARGS((const char *, const char *));
char *strstr  __ARGS((const char *, const char *));
char *strtok  __ARGS((char *, const char *));

int memcmp  __ARGS((const void *, const void *, size_t));
int strcmp  __ARGS((const char *, const char *));
int strncmp __ARGS((const char *, const char *, size_t));
int strcoll __ARGS((const char *, const char *));

size_t strlen  __ARGS((const char *));
size_t strcspn __ARGS((const char *, const char *));
size_t strspn  __ARGS((const char *, const char *));
size_t strxfrm __ARGS((char *, const char *, size_t));

char *strerror __ARGS((int));

#if __STDC__ == 0
char *index  __ARGS((const char *, const char));
char *rindex __ARGS((const char *, const char));
#endif

#undef __ARGS
#undef __VOIDPTR
#ifdef __cplusplus
}
#endif
#endif      /* _STRING_H */
