/***********************************************************************
<t@C>	zdam.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************************************
		yc`l(ZAURUS Data Access Manager)
*****************************************************************/
#ifndef _ZDAM_H_DEFINED
#define	_ZDAM_H_DEFINED
#include <sharpgen.h>
#include <dtmlib.h>
#include <cliplib.h>

/* anwt@C쐬x */
typedef enum FINITLEVEL {
	INIT_CAREFULLY,		/* ALL RESET - RESET */
	INIT_NORMALLY,		/* ON */
	INIT_SIMPLY			/* IN - START UP CHECK */
} FINITLEVEL;

/* t@CXe[^X */
typedef USHORT	FILESTAT;

#define	FS_READY	0
#define	FS_RETRY	1
#define	FS_NOT_EXEC	2


/* {[rbg */
#define	VA_NECESSARY	0x01	/* K{{[ */
#define	VA_NOT_USE		0x02	/* gp{[ */

/* {[ */
typedef struct VOLUMEINFO {
	FILESTAT	FileStatus;		/* t@CXe[^X */
	UCHAR		VolumeAttr;		/* {[ */
	UCHAR		Reserved;		/* \ */
	VOLUMENAME	VolumeName;		/* {[ */
} VOLUMEINFO;

/* t@CǗ񏉊\[X */
typedef struct FILEINFORES {
	DTMFNAME	BoxFName;			/* BOXt@C */
	ULONG		Reserved1;
	ULONG		Reserved2;
	ULONG		Reserved3;
	USHORT 		IndexNum;			/* INDEXt@C̐ */
	DTMFNAME	IndexFName[1];		/* CfbNXt@C() */
} FILEINFORES;

/* t@CǗ */
typedef struct FILEINFO {
	DTMFNAME	BoxFName;			/* BOXt@C */
	VOLUMEINFO	(*VolumeInfo)[1];	/* {[(ϔz)|C^ */
	BOXHANDLE	BoxHandle;			/* BOXt@CI[vnh */
	DTMFNAME	*CrntIndex;			/* INDEXt@C|C^ */
	UCHAR		VolumeNum;			/* {[̐ */
	UCHAR		CrntVolume;			/* ڃ{[ԍ */
	UCHAR		IndexNum;			/* INDEXt@C̐ */
	DTMFNAME	IndexFName[1];		/* CfbNXt@C() */
} FILEINFO;

/* ڏ񃊃\[X\ */
typedef struct FITEMINFO {
	RESFNAME	ResFName;		/* \[Xt@C */
	USHORT		DefItem;		/* ftHgڏ */
	USHORT		ItemNum;		/* ڐ */
	RESID		ResID[1];		/* \[XIDz(ϔz) */
} FITEMINFO;

/* tB[htO */
#define	ZD_NORMAL_FIELD	0
#define	ZD_NOP_FIELD	1		/* ۂ̏sȂ */
#define	ZD_COPY_FIELD	2		/* ̃J[hRs[(writê) */
#define	ZD_CTIME_FIELD	3		/* ݂̎(GMT) */
#define	ZD_FORMAT_FIELD	4		/* FormatɂĐ` */
#define	ZD_LCTIME_FIELD	5		/* ݂̎([J) */
#define	ZD_OFFSET_FIELD	6		/* ItZbgw(⏕IȂ) */
#define	ZD_GETBUF_FIELD	7		/* Kvȃobt@pӂ(Read̂) */

/* f[^`IvV */
#define	ZD_FORM_RAW		0		/* `͍sȂ */
#define	ZD_FORM_YMDHM	1		/* TIME^̂ݎw\ */
#define	ZD_FORM_MD		2		/* TIME^̂ݎw\ */
#define	ZD_FORM_MWD		3		/* WEEK_DAY^̂ݎw\ */
#define	ZD_FORM_CTGR	4		/* JeS[IDt@Cϊ */

/* f[^`x */
#define	ZD_YMD_Y_OFS	0
#define	ZD_YMD_M_OFS	4
#define	ZD_YMD_D_OFS	6
#define	ZD_YMD_W_OFS	8
#define	ZD_YMD_H_OFS	9
#define	ZD_YMD_MN_OFS	11
#define	ZD_YMD_AP_OFS	13
#define	ZD_YMD_BUF_SIZE	15

#define	ZD_MD_M_OFS		0
#define	ZD_MD_D_OFS		2
#define	ZD_MD_BUF_SIZE	5

#define	ZD_MWD_M_OFS	0
#define	ZD_MWD_W_OFS	2
#define	ZD_MWD_D_OFS	3
#define	ZD_MWD_BUF_SIZE	5

typedef struct ZDFIELD {
	ITEMNAME	ItemName;		/* ڎʖ */
	UCHAR		FieldFlag;		/* tO */
	UCHAR		Format;			/* f[^`IvV */
	UCHAR		IsNecessary;	/* K{ڂǂ(ZDWriteDataFromZEX) */
	DATALEN		ItemLen;		/* f[^(NULL܂܂) */
	PTR			ItemBuf;		/* f[^AhX */
	UINT		Offset;			/* ǂݏItZbg */
} ZDFIELD;

/* J[hf[^ */
typedef struct ZDCARDINFO {
	ZDFIELD		(*Field)[1];	/* ڏ(ϔz|C^) */
	USHORT		ItemNum;		/* ڂ̐ */
	CARDID		TargetCard;		/* ΏۃJ[hID */
	CARDID		SourceCard;		/* J[hID */
} ZDCARDINFO;

/* ftHgڏ */
#define	IS_CTGR_ITEM	0x01
#define	IS_LKIF_ITEM	0x02
#define	IS_LKDT_ITEM	0x04

/* ZDWriteDataFromZEX`FbN֐߂l */
#define	CD_CONTINUE		0
#define	CD_SKIP			1
#define	CD_STOP			2

typedef enum CDP_MODE {
	CDP_ITEM_WRITE,
	CDP_CARD_COPY
} CDP_MODE;

/* ZDAMG[R[h */
typedef enum ZDAMERR {
	ZD_NO_ERR,					/*  */
	ZD_MEMORY_ERR,				/* G[ */
	ZD_FATAL_ERR,				/* ̑̒vIȃG[ */
	ZD_ABORT_ERR,				/* A{[gɂ钆f */
	ZD_DATA_NF_ERR				/* f[^Ȃ */
} ZDAMERR;

/* t@C^Cve[u\ */
/* typedef struct FILETYPETABLE { */
/* 	FILETYPE	FileType;	*/	/* t@C^Cv */
/* 	USHORT		FileNum;	*/	/* t@C̐ */
/* 	DTMFNAME	BoxName[1];	*/	/* t@C(ϔz) */
/* } FILETYPETABLE; */

/* ZDCARDINFÕftHgڒ` */
#define	ZD_ATTR_FIELD	0
#define	ZD_TPID_FIELD	1
#define	ZD_MDTM_FIELD	2
#define	ZD_MISC_FIELD	3

#define	ZD_USER_FIELD	4

/* {[ԍ` */
/* {[ԍƃhCu̕ϊe[uZDAM */
#define	MAIN_VOLUME		1
#define	CARD_VOLUME		2

/* ֐` */
FILEINFO*	ZDNewFileInfo(RESOURCE *InitRes);
void		ZDDisposeFileInfo(FILEINFO *FInfo);
void		ZDSetupFile(FILEINFO *FInfoPtr, APLID AplName,
						USHORT Level,RESOURCE *ItemRes,RESOURCE *IdxInfoRes);
void		ZDSetupFileVolume(FILEINFO *FInfoPtr, APLID AplName,
							  USHORT Level,RESOURCE *ItemRes,
							  RESOURCE *IdxInfoRes,UCHAR VolumeNo);
BOOLEAN		ZDOpenFile(FILEINFO *FInfoPtr);
void		ZDCloseFile(FILEINFO *FInfoPtr);
ZDAMERR		ZDReadData(FILEINFO *FInfoPtr,ZDCARDINFO *CardInfo);
ZDAMERR		ZDReadItem(FILEINFO *FInfoPtr,ZDFIELD *Field,CARDID TargetCardID);
ZDAMERR		ZDWriteData(FILEINFO *FInfoPtr,ZDCARDINFO *CardInfo);
ZDAMERR		ZDWriteItem(FILEINFO *FInfoPtr,ZDFIELD *Field,
						CARDID TargetCardID,CARDID SourceCardID);
ZDAMERR		ZDWriteItemWithUpdate(FILEINFO *FInfoPtr,ZDFIELD *Field,
								  CARDID TargetCardID,CARDID SourceCardID);
ZDAMERR		ZDWriteBitItem(FILEINFO *FInfoPtr,CARDID TargetCardID,
						   ITEMNAME ItemName,UCHAR BitData,
						   BOOLEAN IsSet,BOOLEAN IsUpdate);
ZDCARDINFO	*ZDNewCardInfo(RESOURCE *ItemRes);
void		ZDDisposeCardInfo(ZDCARDINFO *CardInfo);
BOOLEAN 	ZDSetCrntVol(FILEINFO *FInfoPtr,UCHAR Volume);
BOOLEAN 	ZDSetCrntIndex(FILEINFO *FInfoPtr,UCHAR Index);
BOOLEAN		ZDGetNext(FILEINFO *FInfoPtr,CARDID *CardID);
BOOLEAN		ZDGetPrev(FILEINFO *FInfoPtr,CARDID *CardID);
void		ZDSetAttrCond(UCHAR *AttrMask,UCHAR *AttrCond,UCHAR *AttrFlag);
ZDAMERR		ZDSetupTDXFile(FILEINFO *FInfoPtr,DTMFNAME *TDXFName,
						   UCHAR TargetMasterIndex,BOOLEAN IsDataNFErr,
						   STRING SearchCond,USHORT SearchCondLen,
						   STRING SortCond,USHORT SortCondLen);
ZDAMERR		ZDWriteDataFromZEX(FILEINFO *FInfoPtr,ZDCARDINFO *CardInfo,
							   CLIPID ClipNo,APLID AplName,
							   CBPROC *CheckDataProc,void *CBWork);
void		ZDImportCrntIndex(FILEINFO *FInfoPtr,DTMFNAME *IndexFName);
BOOLEAN		ZDDeleteData(FILEINFO *FInfoPtr,CARDID *CardID);
BOOLEAN		ZDTimeToYMDHM(STRING AscBuf,TIME *Time);
BOOLEAN		ZDYMDHMToTime(TIME *Time,STRING AscBuf);
BOOLEAN		ZDWriteDataToZEX(FILEINFO *FInfoPtr,ZDCARDINFO *CardInfo,
							 CLIPID ClipNo,CLIPNAME ClipName,
							 APLID AplName,STRING AplNameStr,
							 STRING CommentBuf,ULONG CommentLen);
void		ZDDisableVolume(FILEINFO *FInfoPtr,UCHAR VolumeNo);
BOOLEAN		ZDOpenFileEx(FILEINFO *FInfoPtr);
ZDAMERR		ZDDuplicateData(FILEINFO *FInfoPtr,CARDID *CardID);
ZDAMERR		ZDWriteDataFromZEXClip(FILEINFO *FInfoPtr,ZDCARDINFO *CardInfo,
								   CLIPID ClipNo,CLIPNAME ClipName,
								   APLID AplName,
								   CBPROC *CheckDataProc,void *CBWork);

/* }N` */
#ifndef H2EQU
#define	ZDGetBoxNamePtr(finfo)		(&(finfo)->BoxFName)
#define	ZDGetBoxHandle(finfo)		((finfo)->BoxHandle)
#define	ZDGetCrntIdxNamePtr(finfo)	((finfo)->CrntIndex)
#define	ZDGetIdxNamePtr(finfo,idx)	(&(finfo)->IndexFName[(idx)-1])
#define	ZDGetFileStatus(finfo,vol)	\
((*(finfo)->VolumeInfo)[(vol)-1].FileStatus)

#define	ZDGetCrntFileStatus(finfo)	\
((*(finfo)->VolumeInfo)[finfo->CrntVolume-1].FileStatus)

#define	ZDGetVolumeAttr(finfo,vol)	\
((*(finfo)->VolumeInfo)[(vol)-1].VolumeAttr)
#define	ZDSetVolumeAttr(finfo,vol,attr)	\
((*(finfo)->VolumeInfo)[(vol)-1].VolumeAttr = attr)
#define	ZDMakeVolumeNecessary(finfo,vol)	\
((*(finfo)->VolumeInfo)[(vol)-1].VolumeAttr |= VA_NECESSARY)
#define	ZDMakeVolumeNotUse(finfo,vol)	\
((*(finfo)->VolumeInfo)[(vol)-1].VolumeAttr = VA_NOT_USE)

#define	ZDGetCrntVolNo(finfo)		((finfo)->CrntVolume)
#define	ZDGetVolumeName(finfo,vol)	\
((*(finfo)->VolumeInfo)[(vol)-1].VolumeName)
#define	ZDGetCrntVolumeName(finfo)	\
((*(finfo)->VolumeInfo)[ZDGetCrntVolNo(finfo)-1].VolumeName)

#define	ZDMakeItSecret(finfo,cardid)	\
ZDWriteBitItem(finfo,cardid,			\
			   (UCHAR*)SYS_ATTR_ITEM_NAME,ATTR_MARK,true,false)

#define	ZDMakeItNotSecret(finfo,cardid)	\
ZDWriteBitItem(finfo,cardid,			\
			   (UCHAR*)SYS_ATTR_ITEM_NAME,ATTR_MARK,false,false)

#define	ZDMakeItDeleted(finfo,cardid)	\
ZDWriteBitItem(finfo,cardid,			\
			   (UCHAR*)SYS_ATTR_ITEM_NAME,ATTR_DELETE,true,false)

#define	IsZDBoxOpened(finfo)		((finfo)->BoxHandle != NULL)
#define	IsVolumeAvailable(finfo,vol)	\
((finfo)->VolumeNum >= (vol) && ZDGetCrntFileStatus(finfo) == FS_READY)
#endif H2EQU

/* t@NVԍ */
#define	ZD_NEW_FILE_INFO			0x41
#define	ZD_DISPOSE_FILE_INFO		0x42
#define	ZD_SETUP_FILE				0x43
#define	ZD_OPEN_FILE				0x44
#define	ZD_READ_DATA				0x45
#define	ZD_READ_ITEM				0x46
#define	ZD_WRITE_DATA				0x47
#define	ZD_WRITE_ITEM				0x48
#define	ZD_GET_NEXT					0x49
#define	ZD_GET_PREV					0x4a
#define	ZD_DELETE_DATA				0x4b
#define	ZD_CLOSE_FILE				0x4c
#define	ZD_NEW_CARD_INFO			0x4d
#define	ZD_DISPOSE_CARD_INFO		0x4e
#define	ZD_SET_CRNT_VOL				0x4f
#define	ZD_SET_CRNT_INDEX			0x50
#define	ZD_SET_ATTR_COND			0x51
#define	ZD_SETUP_TDX_FILE			0x52
#define	ZD_WRITE_DATA_FROM_ZEX		0x53
#define	ZD_WRITE_ITEM_WITH_UD		0x54
#define	ZD_WRITE_BIT_ITEM			0x55
#define	ZD_IMPORT_CRNT_INDEX		0x56
#define	ZD_TIME_TO_YMDHM			0x57
#define	ZD_YMDHM_TO_TIME			0x58
#define	ZD_WRITE_DATA_TO_ZEX		0x59
#define	ZD_SETUP_FILE_VOLUME		0x5a
#define	ZD_DISABLE_VOLUME			0x5b
#define	ZD_OPEN_FILE_EX				0x5c
#define	ZD_DUPLICATE_DATA			0x5d
#define	ZD_WRITE_DATA_FROM_ZEX_CLIP	0x5e

#define	ZDAM_LAST_FUNC			ZD_WRITE_DATA_FROM_ZEX_CLIP

#endif
