/***********************************************************************
<t@C>	zdrawlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
	    ZDraw(LCD IOCS)Cu
***********************************************************************/
#ifndef	_ZDRAW_LIB_H_DEFINED
#define	_ZDRAW_LIB_H_DEFINED
#include <sharpgen.h>

/* e^` */
/***********************************************************************
  J[ - 24bitJ[VXeW`
***********************************************************************/
typedef struct RGBCOLOR {
	UCHAR	blue;
	UCHAR	green;
	UCHAR	red;
	UCHAR	info;
} RGBCOLOR;

typedef union COLOR {
	RGBCOLOR	rgb;
	long		CValue;
} COLOR;

/* \IȐF̒` */
#define	BLACK	0x000000
#define	RED	0xff0000
#define	GREEN	0x00ff00
#define	BLUE	0x0000ff
#define	WHITE	0xffffff
#define	YELLOW	0xffff00
#define	MAGENTA	0xff00ff
#define	CYAN	0x00ffff

#define	GRAY	0x808080
#define	ORANGE	0xffa500

/* WO[ */
#define	LIGHT_GRAY		0xcdcdcd		/* 205,205,205 */
#define	S_LIGHT_GRAY	0xcccccc		/* 204,204,204 */
/* #define	LIGHT_GRAY		0xb9b9b9 */
/* #define	S_LIGHT_GRAY	0xbbbbbb */

/* ɔO[ */
#define	LIGHT_GRAY2		0xdcdcdc
#define	LIGHT_GRAY3		0xededed

/* ftHgrF */
#define	DEF_H_LINE_COLOR	0xdddddd	/* r */
#define	DEF_V_LINE_COLOR	0xaaaaaa	/* cr */

/* AM,PM\F */
#define	TIME_AM_COLOR		0x0066cc	/* 0,102,204 */
#define	TIME_PM_COLOR		0xff6600	/* 255,102,0 */

/* ŏʃoCg */
/* F */
#define	INVALID_COLOR	0x01
#define	INVALID_COLOR_L	INVALID_COLOR*256*256*256
/* ftHgF */
#define	CI_DEFAULT_COLOR	0x02	/* CI:ColorInfo */
#define	CI_DEFAULT_COLOR_L	(CI_DEFAULT_COLOR*256*256*256)

#ifndef H2EQU

/* J[\̂24bitJ[lZbg */
#define	SetColorV(color,value)			(color)->CValue = value

/* J[\̂24bitJ[l݂ */
#define	GetColorV(color)				(color)->CValue

/* J[\̂r,g,btB[hZbg */
#define	SetColorRGB(color,r,g,b)		((color)->rgb.red	= (r),	\
										 (color)->rgb.green = (g),	\
										 (color)->rgb.blue	= (b))

/* J[\̂̊etB[hZbg */
#define	SetColorInfo(color,value)	((color)->rgb.info = value)
#define	SetColorR(color,value)		((color)->rgb.red = value)
#define	SetColorG(color,value)		((color)->rgb.green = value)
#define	SetColorB(color,value)		((color)->rgb.blue = value)
#define	GetColorInfo(color)			(color)->rgb.info
#define	GetColorR(color)			(color)->rgb.red
#define	GetColorG(color)			(color)->rgb.green
#define	GetColorB(color)			(color)->rgb.blue

/* Fɐݒ肷 */
/* Frbg𗧂Ă邾ŁA͕ۑ */
#define	SetColorInvalid(color)	((color)->rgb.info|=INVALID_COLOR)
/* ftHgFɐݒ肷 */
#define	SetColorDefault(color)	((color)->rgb.info|=CI_DEFAULT_COLOR)

#endif H2EQU

/***********************************************************************
  J[\[h
***********************************************************************/
typedef UCHAR	CDSPMODE;

/* dˍ킹̐ݒ */
#define	FBSET			0
#define	FSET			1
#define	BSET			2
#define	FBEX			3
/* ȉAreaClear()ł̂ݎgp\ - ł͎gpsI */
#define	FDARK			4			/* 1/2e */
#define	FDARK_LIGHT		5			/* 3/4e */
#define	FDARK_DEEP		6			/* 1/4e */
/* ȉDrawLine(),BoxLine()ł̂ݎgp\ - ł͎gpsI */
#define	FREV			4			/* F]Z\ */

/* dˍ킹}XN */
#define	DSPMODE_TMODE	0x07


/* ̑ */
#define FRAME_MASK_ON	8

/* \[ĥ */
#define	QP16_CHR			0x00	/* Shbg */
#define	QP24_CHR			0x10	/* Uhbg */
#define QP32_CHR			0x20	/* Whbg */
#define	QP40_CHR			0x30	/* POhbg */
#define QP48_CHR			0x40	/* PQhbg */
#define	QP56_CHR			0x50	/* PShbg */
#define QP64_CHR			0x60	/* PUhbg */
#define	QP72_CHR			0x70	/* PWhbg */
#define	QP80_CHR			0x80	/* QOhbg */
#define	QP96_CHR			0x90	/* QShbg */
#define	QP128_CHR			0xa0	/* RQhbg */
#define	QP144_CHR			0xb0	/* RUhbg */
#define	QP160_CHR			0xc0	/* SOhbg */
#define	QP192_CHR			0xd0	/* SWhbg */

/* TCY}XN邽߂̂ */
#define	DSPMODE_CHR_SIZE	0xf0	/* 11110000b */

/***********************************************************************
  _̑傫
***********************************************************************/
typedef UCHAR	DOTSIZE;

#define	NORM_DOTSIZE	4

/***********************************************************************
  _̌`
***********************************************************************/
typedef UCHAR	DOTSHAPE;

#define	DOT_WHITE		0
#define	DOT_BLACK		1
#define	DOT_GRAY		2
#define	DOT_CIRCLE		0x00
#define	DOT_SQUARE		0x10

#define	NORM_DOT_SHAPE	DOT_BLACK+DOT_SQUARE

/***********************************************************************
  p^[
***********************************************************************/
typedef UCHAR	LINEPAT;
typedef USHORT	LINEPATDATA;

#define	USE_LINE_PAT_DATA	0	/* [Uw̃Cp^[gp */
#define SOLID_LINE			1	/*      ---------- */
#define	DOTTED_LINE			2	/* _     - - - - - -*/
#define	LIGHT_DOTTED_LINE	3	/* _ -  -  -  - */
#define	BROKEN_LINE			4	/* j     --  --  -- */
#define	DOT_CHAINED_LINE	5	/* P_ --  -  --  */

#define	LAST_LINEPAT	DOT_CHAINED_LINE

/***********************************************************************
  hp^[
***********************************************************************/
typedef UCHAR	PAINTPAT;

#define P_BLACK			1		/* x^h */
#define P_DARK_GRAY		2		/* ZO[(Ԃ) */
#define P_GRAY			3		/* O[(Ԃ) */
#define P_LIGHT_GRAY	4		/* WO[(Ԃ) */
#define BORDER			5		/*  */
#define STRIPE			6		/* c */
#define RIGHT_INCLINE	7		/* Eオ̎ */
#define LEFT_INCLINE	8		/* オ̎ */
#define	CHECKS			9		/* s͗li_ʒuقȂ) */
#define	H_BRICK			10		/* ̃K͗l */
#define	HEART_SHAPED	11		/* n[g͗l */

#define DR_ROUND		101		/* pۘg\ */

/***********************************************************************
  ACR\[h
***********************************************************************/
typedef UCHAR	ICONMODE;

#define	ICON_NORMAL		0		/* ʏ\ */
#define	ICON_REVERSE	1		/* ]\ */
#define	ICON_SELECT		2		/* I\ */
#define	ICON_DISABLE	3		/* Is\ */

/***********************************************************************
  ACRf[^
***********************************************************************/
typedef struct	ICONDATA {
	USHORT	DataSize;			/* f[^Ŝ̃oCg */
	USHORT	Width;				/* ACRTCY(QP-1) */
	USHORT	Height;				/* ACRcTCY(QP-1) */
	DOTSIZE	Dot;				/* _̑傫 */
	UCHAR	DataInfo;			/* f[^ */
	USHORT	DispSize;			/* \f[^̃oCg */
	USHORT	AreaSize;			/* GAf[^̃oCg */
	UCHAR	GUIColorMap[1];		/* f[^{(ϒ) */
} ICONDATA;

/* f[^̃rbg` */
#define	I_NORMAL_DATA	0x01	/* ʏf[^       b'00000001 */
#define	I_VAREA_DATA	0x02	/* LGAf[^ b'00000010 */
#define	I_REVERSE_DATA	0x04	/* ]\f[^   b'00000100 */
#define	I_MAREA_DATA	0x08	/* \}XNf[^ b'00001000 */

/* GUIJ[e[u؂ւȂ */
/* ACR̒ʏf[^ȊÕf[^pӂĂꍇA炪 */
/* ɔ]FȂǂ̏荞łꍇɎgp */
#define	I_NOT_SWITCH_GCTABLE	0x80

/***********************************************************************
  GUIJ[֘A
***********************************************************************/
typedef USHORT	GCTABLESET;

#define	NORM_GCTABLESET	1

typedef UCHAR	GUICOLOR;

/* ӁIȉ̒`ICONMODEƑΉĂ */
typedef enum	GCTABLE {
	GT_NORMAL = 0,		/* ʏ\p */
	GT_REVERSE,			/* ]\p */
	GT_SELECT,			/* I\p */
	GT_DISABLE			/* Is\p */
} GCTABLE;

/* F */
#define	GC_BTN_SHADOW	6		/* {^eʃJ[ */
#define	GC_BTN_SL_C		18		/* {^epJ[ */
#define	GC_BTN_LIGHT	207		/* {^ʃJ[ */
#define	GC_BTN_BG		209		/* {^obNOEhJ[ */
#define	GC_BTN_SHADOW_C	240		/* {^epJ[ */
#define	GC_BTN_LIGHT_C	242		/* {^pJ[ */

/* pɂɎgpF */
#define	GC_BLACK		0
#define	GC_BLUE			30
#define	GC_RED			5
#define	GC_MAGENTA		215
#define	GC_GREEN		160
#define GC_CYAN			190
#define	GC_YELLOW		165
#define	GC_WHITE		255

/* {^F */
#define	GC_EXEC			146		/* mn{^̐F */
#define	GC_CANCEL		139		/* ےn{^̐F */

/* VXe`F̃x - t@NVɓnXCb` */
#define	SYS_REVERSE_COLOR		1
#define	SYS_SHADOW_COLOR		2
#define	SYS_DEFAULT_BTN_COLOR	3
#define	SYS_GO_BTN_COLOR		4
#define	SYS_BACK_BTN_COLOR		5

#define	SYS_H_LINE_COLOR		6
#define	SYS_V_LINE_COLOR		7
#define	SYS_TIME_AM_COLOR		8
#define	SYS_TIME_PM_COLOR		9
#define	SYS_BACK_COLOR			10
#define	SYS_FORE_COLOR			11
#define	SYS_F_BACK_COLOR		12
#define	SYS_F_FORE_COLOR		13
#define	SYS_FRAME_LINE_COLOR	14
#define	SYS_DIALOG_BACK_COLOR	15
#define	SYS_MENU_BACK_COLOR		16
#define	SYS_MENU_FORE_COLOR		17

/***********************************************************************
  C[Wf[^
***********************************************************************/
typedef UCHAR IMGTYPE;

typedef struct	IMAGEDATA {
	USHORT	DataSize;			/* f[^Ŝ̃oCg */
	USHORT	Width;				/* C[WTCY(QP-1) */
	USHORT	Height;				/* C[WcTCY(QP-1) */
	UCHAR	DataType;			/* o[W(Crimsonł0) */
	DOTSIZE	Dot;				/* _̑傫 */
	USHORT	ColorDepth;			/* F̐[x(bit - Crimsonł16) */
	USHORT	PixMap[1];			/* f[^{(ϒ) */
} IMAGEDATA;

typedef struct	IMAGEDATA_L {
	USHORT	dummy;				/* gp(0) */
	USHORT	width;				/* C[WTCY(dot) */
	USHORT	height;				/* C[WcTCY(dot) */
	IMGTYPE	dataType;			/* o[W(IMAGE_PIXMAP_L) */
	UCHAR	reserved1;			/* \(0) */
	ULONG	dataLen;			/* f[^Ŝ̒ */
	UCHAR	pixMapType;			/* PixMap^Cv */
	UCHAR	colorDepth;			/* F̐[x(16) */
	UCHAR	compType;			/* k` */
	UCHAR	reserved2;			/* \(0) */
	UCHAR	pixMap[1];			/* f[^{(ϒ) */
} IMAGEDATA_L;

/* f[^^Cv(DataTypeɃZbgׂI) */
#define	IMAGE_16BIT		0				/* 16bitAJ[ */
#define	IMAGE_PIXMAP		IMAGE_16BIT	/* PixMapf[^ */
#define	IMAGE_GUICOLOR		1		/* GUIJ[ */
#define	IMAGE_PIXMAP_L		2		/* PixMapf[^ IMAGEDATA_L*/

/* PixMap^Cv (IMAGEDATA_L) */
#define	PIXMAP_DIRECT_COLOR	0		/* _CNJ[ */
#define	PIXMAP_GUI_COLOR	1		/* GUIJ[ */

#define	PIXMAP_MAX_COLOR_NO	PIXMAP_GUI_COLOR

/* k` (IMAGEDATA_L) */
#define	COMP_NOTHING		0			/* 񈳏k */
#define	COMP_BPE		1			/* BPE */

#define	COMP_MAX_NO			COMP_BPE

/***********************************************************************
  k@
***********************************************************************/
typedef UCHAR	CMPMODE;

#define	COMP_FORM0		0		/* 񈳏k */
#define	COMP_FORM1		1		/* ca[yk */
#define	COMP_FORM2		2		/* au[Qk */

/***********************************************************************
  {
***********************************************************************/
typedef UCHAR	SCALEMODE;

#define	FOUR_TIMES		0x01	/* S{iauQł͖gpj */
#define	NORM_SCALE		0x00	/* TCY */
#define	ONE_FOURTH		0xff	/* ŜP{ */

/***********************************************************************
  \(rbg)
***********************************************************************/
typedef UCHAR	DS_MODE;

#define	DS_NORMAL		0x00
#define	DS_SHADOW		0x00	/* Iɂ͔p~ */
#define	DS_HOLLOWED		0x01	/* 蕶 */
#define	DS_CONVEX		0x02	/*  */

#define	DS_TYPE_MASK	0x0f

#define	DS_RET_NEXT_POS	0x80	/* ̕\ʒuԂ */

/***********************************************************************
  DrawFrame[h
***********************************************************************/
typedef enum DF_MODE {
	DF_HOLLOWED = 0,
	DF_CONVEX,
	DF_CARVED,
	DF_FIELD
} DF_MODE;

/* Px */
#define	USER_SET_LIGHT_ALL	5	/* MI-100ȍ~̋@ł̂ݗL */
#define	USER_SET_LIGHT_AC_ADAPTOR	4
#define	USER_SET_LIGHT_BATTERY		3
#define	RESET_POW_SAVE_MODE		2
#define	SET_POW_SAVE_MODE		1
#define	NORMAL_LIGHT_MODE		0

#define	LOW_POW_LIGHT		4
#define	NORMAL_LIGHT		3
#define	MID_LIGHT		2
#define	HI_MID_LIGHT		1
#define	HI_LIGHT		0

/* enum̃TCYSoCgłO... */
#define	DF_ROUND	0x80000000

/***********************************************************************
  DPI
***********************************************************************/
typedef USHORT	DPI;

#define	ERROR_DPI		   	0
#define	DPI_140				140
#define	DPI_070				70

/***********************************************************************
  X[XXN[p^[
***********************************************************************/
typedef UCHAR	SMSPTN;
#define	SMS_NORMAL	0	/*  */

/***********************************************************************
  X[XXN[
***********************************************************************/
typedef UCHAR	SMSDIRCT;
#define	SMS_UD		0	/* c */
#define	SMS_LR		1	/*  */

/***********************************************************************
  VRAM
***********************************************************************/
/* VRAM̏cTCYLCD̏cTCY͕Kɂ͂ȂȂ */
/* ӂĉ */
#define	VRAM_WIDTH		1024
#define	VRAM_HEIGHT		480
#define	VRAM_DEPTH		16

/* ֐錾 */
void Disp1Char(WINDOWHD WnHandle, POINT *Where,
			   COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			   USHORT JSCode, USHORT Pitch, RECTANGLE *Mask);

void Disp1C(WINDOWHD WnHandle, POINT *Where,
			COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			USHORT JSCode, USHORT Pitch, RECTANGLE *Mask);

void DispNChar(WINDOWHD WnHandle, POINT *Where,
			   COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			   PTR Str, USHORT Len, USHORT Pitch, RECTANGLE *Mask);

void DispNC(WINDOWHD WnHandle, POINT *Where,
			COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			PTR Str, USHORT Len, USHORT Pitch, RECTANGLE *Mask);

void DispPoint(WINDOWHD WnHandle, POINT *Where,
			   COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			   DOTSIZE Dot, RECTANGLE *Mask);

void DispPointShape(WINDOWHD WnHandle, POINT *Where,
			   COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			   DOTSIZE Dot, DOTSHAPE DotShape, RECTANGLE *Mask);

void DrawLine(WINDOWHD WnHandle, POINT *Start, POINT *End,
			  COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			  LINEPAT Line, DOTSIZE Dot, RECTANGLE *Mask);

void DrawContLine(WINDOWHD WnHandle, POINT *Start, POINT *End,
				  COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
				  LINEPAT Line, DOTSIZE Dot, RECTANGLE *Mask);

void DrawLineShape(WINDOWHD WnHandle, POINT *Start, POINT *End,
				   COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
				   LINEPAT Line,
				   DOTSIZE Dot, DOTSHAPE DotShape, RECTANGLE *Mask);

void DrawLineSpecial(WINDOWHD WnHandle, POINT *Start, POINT *End,
					 COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
					 LINEPAT Line, LINEPATDATA *LinePatData,
					 DOTSIZE Dot, DOTSHAPE DotShape, RECTANGLE *Mask);

void BoxPaint(WINDOWHD WnHandle, POINT *Start, POINT *End,
			  COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			  PAINTPAT Pattern, RECTANGLE *Mask);

void BoxPaintOffset(WINDOWHD WnHandle, POINT *Start, POINT *End,
					COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
					PAINTPAT Pattern, RECTANGLE *Mask, POINT *Offset);

void BoxLine(WINDOWHD WnHandle, POINT *Start, POINT *End,
			 COLOR *Fg, COLOR *Bg, CDSPMODE Mode,
			 LINEPAT Line, DOTSIZE Dot, RECTANGLE *Mask);

void DispIcon(WINDOWHD WnHandle, POINT *Where,
			  CDSPMODE Mode, ICONMODE IcnMode, GCTABLESET GCTableSetNo,
			  ICONDATA *IconData, RECTANGLE *Mask);

void BoxMove(WINDOWHD WnHandle, POINT *Start, POINT *End, POINT *Dist,
			 COLOR *Color, CDSPMODE Mode, BOOLEAN IsClear,
			 RECTANGLE *Mask);

void ScrollUp(WINDOWHD WnHandle, POINT *Start, POINT *End, 
			  COLOR *Color, CDSPMODE Mode, BOOLEAN IsClear,
			  USHORT ScrlQP);

void ScrollDown(WINDOWHD WnHandle, POINT *Start, POINT *End,
				COLOR *Color, CDSPMODE Mode, BOOLEAN IsClear,
				USHORT ScrlQP);

void ClearWindow(WINDOWHD WnHandle, COLOR *Color);

void AreaClear(WINDOWHD WnHandle, POINT *Start, POINT *End,
			   COLOR *Color, CDSPMODE Mode,
			   RECTANGLE *Mask);

void ChrCursorMove(WINDOWHD WnHandle,USHORT whereX,USHORT whereY);

void ChrCursorDisp(WINDOWHD WnHandle,USHORT type,COLOR *fg,COLOR *bg);

void GetRealColorFromGC(COLOR *Color,GUICOLOR GUIColor,
						GCTABLE GCTableNo,GCTABLESET GCTableSetNo);

int GetGCFromRealColor(GUICOLOR *GUIColor,COLOR *Color,
						   GCTABLE GCTableNo,GCTABLESET GCTableSetNo);

void GetFont(USHORT JSCode,CDSPMODE Mode,
			 UCHAR *Bitmap,USHORT *Width,USHORT *Height);
void GetFontOffscreen(USHORT JSCode,CDSPMODE Mode,
					  UCHAR *Bitmap,USHORT *Width,USHORT *Height);

void GetScreenSize(UPOINT *ScreenSize);
void GetSystemColor(COLOR *Color,UCHAR SysColor);

void DrawOffscreen(WINDOWHD WnHandle,RECTANGLE *Where,
				   WINDOWHD	OSHandle,RECTANGLE *SrcRect,
				   CDSPMODE Mode,RECTANGLE *Mask,COLOR *fg,COLOR *bg);

void DispImage(WINDOWHD WnHandle,RECTANGLE *Where,CDSPMODE Mode,
			   IMAGEDATA *Image,SCALEMODE Scale,RECTANGLE *Mask);

void DummyDispImage(WINDOWHD WnHandle,RECTANGLE *Where,CDSPMODE Mode,
					void *ImageData,RECTANGLE *Mask);

IMAGEDATA *PutImageToBuffer(WINDOWHD WnHandle,RECTANGLE *WnRect,
							IMAGEDATA *Image,USHORT Size,UCHAR DataType);

WINDOWHD PutPixMapToOffscreen(WINDOWHD WnHandle,RECTANGLE *WnRect,
							  WINDOWHD OSHandle,RECTANGLE *SrcRect,
							  UCHAR DataType);
UCHAR GetLight(void);
void SetLight(UCHAR,UCHAR);
void DispNVPattern(WINDOWHD WnHandle,POINT *Where,
				   COLOR *Fg,COLOR *Bg,CDSPMODE Mode,
				   USHORT *Buffer,USHORT Raws,RECTANGLE *Mask);

USHORT ReadPoint(WINDOWHD WnHandle,POINT *Where,CDSPMODE Mode,
				 DOTSIZE Dot,RECTANGLE *Mask);

/* 4byteTCY(ULONG Size) PutImageToBuffer() */
IMAGEDATA_L *PutImageToBufferL(WINDOWHD WnHandle,RECTANGLE *WnRect,
				   IMAGEDATA_L *Image,ULONG Size,
				   UCHAR DataType);

/* X[XXN[ */
void SmoothScroll(WINDOWHD WnHandle,RECTANGLE *WnRect,SMSPTN Pattern,
			  SMSDIRCT Direction,short Distance,USHORT Time,
			  USHORT *PixMapUD,USHORT *PixMapLR,COLOR *Fg);

/* EBhE */
#define	DESK_TOP	0x09

/* e}N */
#define	AreaDark(w,s,e,mode,mask)	AreaClear(w,s,e,NULL,mode,mask)

#endif
